local camx, camy = 0, 0
local windowx, windowy = 800, 600
local ismousedown = false
local oldpos = {}
local wires = {}
local mode, currentnodeid, currentwireid = "view", 0, 1
local wireid = 1
function love.conf(t) t.console = true end
local function findremainder(number, divedent)
	return (number / divedent) - math.floor(number / divedent)
end
function love.draw()
	love.graphics.setColor(0.9, 0.9, 0.9)
	love.graphics.rectangle("fill", 0, 0, windowx, windowy)
	love.graphics.setColor(0.6, 0.6, 0.6)
	for y = 0 + (findremainder(camy, 15) * 15), windowy + (findremainder(camy, windowy) * 15), 15 do
		love.graphics.rectangle("fill", 0, y, windowx, 1)
	end
	for x = 0 + (findremainder(camx, 15) * 15), windowx + (findremainder(camx, windowx) * 15), 15 do
		love.graphics.rectangle("fill", x, 0, 1, windowy)
	end
	love.graphics.setColor(0, 0, 0)
	love.graphics.print("Mode: "..mode, 5, 5)
	for i = 1, #wires do
		for k = 1, #wires[i] do
			love.graphics.setColor(0.5, 0.5, 0.5)
			love.graphics.ellipse("fill", wires[i][k][1] + camx, wires[i][k][2] + camy, 5, 5)
			if wires[i][k] ~= nil then if wires[i][k + 1] ~= nil then
			love.graphics.line(wires[i][k][1] + camx, wires[i][k][2] + camy, wires[i][k + 1][1] + camx, wires[i][k + 1][2] + camy) end end
		end
	end
	if mode == "Place wire" then
		
	end
end
local function placewirenode(x, y, id)
	if wires[id] == nil then wires[id] = {} end
	currentnodeid = currentnodeid + 1
	wires[id][currentnodeid] = {x, y}
	print(currentnodeid, #wires[id])
end
function love.keypressed(key)
	if key == "space" and mode == "view" then
		mode = "Place wire"
		currentnodeid = 0
		placewirenode(love.mouse.getX() - camx, love.mouse.getY() - camy, currentwireid)
	end
end
function love.mousepressed(x, y, button)
	if mode == "Place wire" then
		print("place wire")
		placewirenode(love.mouse.getX() - camx, love.mouse.getY() - camy, currentnodeid)
	end
end
function love.update()
	if mode == "view" then
		if love.mouse.isDown(1) then
			local mouseoffset = {love.mouse.getX() - oldpos[1], love.mouse.getY() - oldpos[2]}
			camx = camx + mouseoffset[1]
			camy = camy + mouseoffset[2]
		else
			originalpos = {love.mouse.getX(), love.mouse.getY()}
		end
		oldpos = {love.mouse.getX(), love.mouse.getY()}
	end
end